/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function r(s,o,d){function u(a,e){if(!o[a]){if(!s[a]){var t="function"==typeof require&&require;if(!e&&t)return t(a,!0);if(l)return l(a,!0);var n=new Error("Cannot find module '"+a+"'");throw n.code="MODULE_NOT_FOUND",n}var i=o[a]={exports:{}};s[a][0].call(i.exports,function(e){var t=s[a][1][e];return u(t||e)},i,i.exports,r,s,o,d)}return o[a].exports}for(var l="function"==typeof require&&require,e=0;e<d.length;e++)u(d[e]);return u}({1:[function(e,t,a){"use strict";var p={isSDKStarted:!1,isSDKLoaded:!1,iframeQueue:[],enqueueIframe:function(e){p.isLoaded?p.createIframe(e):(p.loadIframeApi(),p.iframeQueue.push(e))},loadIframeApi:function(){p.isSDKStarted||(mejs.Utils.loadScript("https://api.dmcdn.net/all.js"),p.isSDKStarted=!0)},apiReady:function(){for(p.isLoaded=!0,p.isSDKLoaded=!0;0<p.iframeQueue.length;){var e=p.iframeQueue.pop();DM.init({apiKey:e.apiKey,status:e.status,cookie:e.cookie}),p.createIframe(e)}},createIframe:function(e){var t=DM.player(e.container,{height:e.height||"100%",width:e.width||"100%",video:e.videoId,params:Object.assign({api:!0},e.params),origin:location.host});t.addEventListener("apiready",function(){window["__ready__"+e.id](t,{paused:!0,ended:!1})})},getDailyMotionId:function(e){var t=e.split("/");return t[t.length-1].split("_")[0]}},n={name:"dailymotion_iframe",options:{prefix:"dailymotion_iframe",dailymotion:{width:"100%",height:"100%",params:{autoplay:!1,chromeless:1,info:0,logo:0,related:0},apiKey:null,status:!0,cookie:!0}},canPlayType:function(e){return~["video/dailymotion","video/x-dailymotion"].indexOf(e.toLowerCase())},create:function(h,e,t){var y={},g=[],E=void 0,j=null,w=null;h.originalNode.muted;y.options=e,y.id=h.id+"_"+e.prefix,y.mediaElement=h;for(var a=mejs.html5media.properties,n=function(n){var e=""+n.substring(0,1).toUpperCase()+n.substring(1);y["get"+e]=function(){if(null!==j){switch(n){case"currentTime":return j.currentTime;case"duration":return isNaN(j.duration)?0:j.duration;case"volume":return j.volume;case"paused":return j.paused;case"ended":return j.ended;case"muted":return j.muted;case"buffered":var e=j.bufferedTime,t=j.duration;return{start:function(){return 0},end:function(){return e/t},length:1};case"src":return h.originalNode.getAttribute("src");case"readyState":return 4}return null}return null},y["set"+e]=function(e){if(null!==j)switch(n){case"src":var t="string"==typeof e?e:e[0].src;j.load(p.getDailyMotionId(t));break;case"currentTime":j.seek(e);break;case"muted":!0===e&&j.setVolume(0),j.setMuted(e),e,setTimeout(function(){var e=mejs.Utils.createEvent("volumechange",y);h.dispatchEvent(e)},50);break;case"volume":j.setVolume(e),0!==e||j.muted?0<e&&j.muted&&(j.setMuted(!1),!1):(j.setMuted(!0),!0),setTimeout(function(){var e=mejs.Utils.createEvent("volumechange",y);h.dispatchEvent(e)},50);break;case"readyState":var a=mejs.Utils.createEvent("canplay",y);h.dispatchEvent(a)}else g.push({type:"set",propName:n,value:e})}},i=0,r=a.length;i<r;i++)n(a[i]);for(var s=mejs.html5media.methods,o=function(e){y[e]=function(){if(null!==j)switch(e){case"play":return j.play();case"pause":return j.pause();case"load":return null}else g.push({type:"call",methodName:e})}},d=0,u=s.length;d<u;d++)o(s[d]);window["__ready__"+y.id]=function(e){if(h.dmPlayer=j=e,g.length)for(var t=0,a=g.length;t<a;t++){var n=g[t];if("set"===n.type){var i=n.propName,r=""+i.substring(0,1).toUpperCase()+i.substring(1);y["set"+r](n.value)}else"call"===n.type&&y[n.methodName]()}w=document.getElementById(y.id);for(var s=function(e){var t=mejs.Utils.createEvent(e.type,y);h.dispatchEvent(t)},o=0,d=(E=["mouseover","mouseout"]).length;o<d;o++)w.addEventListener(E[o],s,!1);h.originalNode.muted?(j.setVolume(0),j.setMuted(!0)):(j.setVolume(j.volume),j.setMuted(!1));for(var u,l=0,c=(E=(E=mejs.html5media.events).concat(["click","mouseover","mouseout"])).length;l<c;l++)"ended"!==(u=E[l])&&j.addEventListener(u,function(e){var t=mejs.Utils.createEvent(e.type,y);h.dispatchEvent(t)});j.addEventListener("ad_start",function(){var e=mejs.Utils.createEvent("play",y);h.dispatchEvent(e),e=mejs.Utils.createEvent("progress",y),h.dispatchEvent(e),e=mejs.Utils.createEvent("timeupdate",y),h.dispatchEvent(e)}),j.addEventListener("ad_timeupdate",function(){var e=mejs.Utils.createEvent("timeupdate",y);h.dispatchEvent(e)}),j.addEventListener("ad_pause",function(){var e=mejs.Utils.createEvent("pause",y);h.dispatchEvent(e)}),j.addEventListener("start",function(){if(j.muted){var e=mejs.Utils.createEvent("volumechange",y);h.dispatchEvent(e)}}),j.addEventListener("video_start",function(){var e=mejs.Utils.createEvent("play",y);h.dispatchEvent(e);var t=mejs.Utils.createEvent("playing",y);h.dispatchEvent(t)}),j.addEventListener("ad_timeupdate",function(){var e=mejs.Utils.createEvent("timeupdate",y);h.dispatchEvent(e)}),j.addEventListener("video_end",function(){var e=mejs.Utils.createEvent("ended",y);h.dispatchEvent(e),h.originalNode.getAttribute("loop")&&j.play()});for(var m=["rendererready","loadedmetadata","loadeddata","canplay"],p=0,v=m.length;p<v;p++){var f=mejs.Utils.createEvent(m[p],y,!0);h.dispatchEvent(f)}};var l=document.createElement("div");l.id=y.id,h.appendChild(l),h.originalNode&&(l.style.width=h.originalNode.style.width,l.style.height=h.originalNode.style.height),h.originalNode.style.display="none";var c=p.getDailyMotionId(t[0].src),m={id:y.id,container:l,videoId:c};return m.params=Object.assign({},y.options.dailymotion),m.params.controls=!!h.originalNode.controls,h.originalNode.autoplay&&(m.params.autoplay=!0),h.originalNode.muted&&(m.params.mute=!0),m.params.api="1",p.enqueueIframe(m),y.hide=function(){y.pause(),w&&(w.style.display="none")},y.show=function(){w&&(w.style.display="")},y.setSize=function(e,t){w&&(w.width=e,w.height=t)},y.destroy=function(){j.destroy()},y}};mejs.Utils.typeChecks.push(function(e){return/\/\/((www\.)?dailymotion\.com|dai\.ly)/i.test(e)?"video/x-dailymotion":null}),window.dmAsyncInit=function(){p.apiReady()},mejs.Renderers.add(n)},{}]},{},[1]);